'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var rxjs = require('rxjs');
var operators = require('rxjs/operators');
require('rxjs/internal/Observable');
require('rxjs/internal/Subscription');
var lodash = require('lodash');
var Subject = require('rxjs/internal/Subject');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var FormContext = /*#__PURE__*/React.createContext({});
var Provider = FormContext.Provider;
    FormContext.Consumer;
var FORM_INIT_STATE = {
  fields: {},
  values: {},
  meta: {
    submitting: false,
    errors: []
  }
};

var FieldActionTypes;

(function (FieldActionTypes) {
  FieldActionTypes["register"] = "REGISTER";
  FieldActionTypes["change"] = "CHANGE";
  FieldActionTypes["destroy"] = "DESTROY";
  FieldActionTypes["throwError"] = "THROW_ERROR";
  FieldActionTypes["clearError"] = "CLEAR_ERROR";
})(FieldActionTypes || (FieldActionTypes = {}));

var FormActionTypes;

(function (FormActionTypes) {
  FormActionTypes["reset"] = "FORM_RESET";
  FormActionTypes["update"] = "FORM_UPDATE";
  FormActionTypes["submit"] = "FORM_SUBMIT";
})(FormActionTypes || (FormActionTypes = {}));

var reducer = function reducer(action, formState) {
  var _a, _b, _c, _d;

  switch (action.type) {
    case FieldActionTypes.register:
      {
        var fields = formState.fields,
            values = formState.values,
            formMeta = formState.meta;
        var payload = action.payload,
            meta = action.meta,
            name = action.name;
        return {
          fields: __assign(__assign({}, fields), (_a = {}, _a[name] = __assign(__assign({}, meta), {
            dirty: false
          }), _a)),
          meta: formMeta,
          values: lodash.set(__assign({}, values), name, payload)
        };
      }

    case FieldActionTypes.change:
      {
        var fields = formState.fields,
            values = formState.values,
            formMeta = formState.meta;
        var payload = action.payload,
            meta = action.meta,
            name = action.name;

        var nextFeilds = __assign(__assign({}, fields), (_b = {}, _b[name] = __assign(__assign(__assign({}, fields[name]), meta), {
          dirty: true
        }), _b));

        return {
          fields: nextFeilds,
          meta: formMeta,
          values: lodash.set(__assign({}, values), name, payload)
        };
      }

    case FieldActionTypes.destroy:
      {
        var meta = action.meta,
            name = action.name;

        if (meta.destroyValueOnUnmount) {
          return __assign(__assign({}, formState), {
            fields: lodash.omit(formState.fields, name),
            values: lodash.omit(formState.values, name)
          });
        }

        return __assign(__assign({}, formState), {
          fields: lodash.omit(formState.fields, name)
        });
      }

    case FieldActionTypes.throwError:
      {
        var fields = formState.fields;
        var payload = action.payload,
            name = action.name;

        var nextFeilds = __assign(__assign({}, fields), (_c = {}, _c[name] = __assign(__assign({}, fields[name]), {
          error: payload
        }), _c));

        return __assign(__assign({}, formState), {
          fields: nextFeilds
        });
      }

    case FieldActionTypes.clearError:
      {
        var fields = formState.fields;
        var name = action.name;

        var nextFeilds = __assign(__assign({}, fields), (_d = {}, _d[name] = __assign(__assign({}, fields[name]), {
          error: undefined
        }), _d));

        return __assign(__assign({}, formState), {
          fields: nextFeilds
        });
      }

    case FormActionTypes.update:
      {
        var fields_1 = formState.fields,
            values = formState.values;
        var changes = action.payload;

        if (!Array.isArray(changes)) {
          throw new Error("updateFormValues should receive an array but get: " + JSON.stringify(changes));
        }

        var nextValues_1 = __assign({}, values);

        var nextFields_1 = __assign({}, fields_1);

        changes.forEach(function (_a) {
          var path = _a.path,
              value = _a.value;

          if (fields_1.hasOwnProperty(path)) {
            lodash.set(nextValues_1, path, value);
            lodash.set(nextFields_1, path + ".dirty", true);
          }
        });
        return __assign(__assign({}, formState), {
          fields: nextFields_1,
          values: nextValues_1
        });
      }

    case FormActionTypes.reset:
      {
        var fields = formState.fields,
            values = formState.values;
        var resetMeta = {
          submitting: false,
          errors: []
        };
        var resetFields = Object.fromEntries(Object.entries(fields).map(function (_a) {
          var key = _a[0],
              value = _a[1];
          return [key, __assign(__assign({}, value), {
            dirty: false,
            error: undefined
          })];
        }));

        var resetValues_1 = __assign({}, values);

        Object.entries(fields).forEach(function (_a) {
          var path = _a[0],
              meta = _a[1];
          lodash.set(resetValues_1, path, meta.defaultValue);
        });
        return {
          values: resetValues_1,
          fields: resetFields,
          meta: resetMeta
        };
      }

    default:
      return formState;
  }
};

var catchErrorDecorator = function catchErrorDecorator(reducer) {
  return function (action, state) {
    var nextState;

    try {
      nextState = reducer(action, state);
    } catch (err) {
      console.error(err);
      nextState = state;
    }

    return nextState;
  };
};

var reducer$1 = catchErrorDecorator(reducer);

var asyncTap = function asyncTap(fn) {
  return rxjs.pipe(operators.delayWhen(function (params) {
    return rxjs.defer(function () {
      return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              return [4
              /*yield*/
              , fn(params)];

            case 1:
              _a.sent();

              return [2
              /*return*/
              ];
          }
        });
      });
    });
  }));
};
var isNil = function isNil(value) {
  return [null, undefined, ''].includes(value);
};
var isEmpty = function isEmpty(value) {
  if (Array.isArray(value)) {
    return value.length === 0;
  }

  if (value.constructor === Object) {
    return Object.keys(value).length === 0;
  }

  return false;
};

var asyncVerifyField = function asyncVerifyField(name, value, required, validate) {
  return __awaiter(void 0, void 0, Promise, function () {
    var fieldIsRequiredErrorMsg, validError;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          fieldIsRequiredErrorMsg = verifyRequiredField(name, value, required);

          if (fieldIsRequiredErrorMsg) {
            return [2
            /*return*/
            , fieldIsRequiredErrorMsg];
          }

          if (!validate) return [3
          /*break*/
          , 2];
          return [4
          /*yield*/
          , validate(value)];

        case 1:
          validError = _a.sent();
          return [2
          /*return*/
          , validError];

        case 2:
          return [2
          /*return*/
          ];
      }
    });
  });
};
var verifyRequiredField = function verifyRequiredField(name, value, required) {
  // if required, check value
  if (required && (isEmpty(value) || isNil(value))) {
    return new Error(name + " is required");
  }
};
var verifyForm = function verifyForm(state) {
  var meta = state.meta,
      fields = state.fields,
      values = state.values; // check if required field is empty and update field meta error

  var fieldPairs = Object.entries(__assign({}, fields)).map(function (_a) {
    var key = _a[0],
        field = _a[1];
    var error = verifyRequiredField(field.displayName || key, lodash.get(values, key), field.required);
    var nextField = error ? __assign(__assign({}, field), {
      error: error
    }) : field;
    return [key, nextField];
  });
  var errors = fieldPairs.filter(function (_a) {
    var field = _a[1];
    return field.error;
  }).map(function (_a) {
    var field = _a[1];
    return field.error;
  });

  if (errors.length === 0) {
    return [null, []];
  }

  var formStateWithError = {
    fields: Object.fromEntries(fieldPairs),
    values: values,
    meta: meta
  };
  return [formStateWithError, errors];
};

var createStore = function createStore(initState, reducer, postUpdate) {
  var actionSubject = new rxjs.Subject();
  var stateSubject = new rxjs.BehaviorSubject(initState);
  var finalStateSubject = new rxjs.BehaviorSubject(initState);
  var actionCache = new rxjs.BehaviorSubject({
    type: '@@INIT'
  });
  var state$ = actionSubject.pipe(operators.withLatestFrom(stateSubject), operators.map(function (_a) {
    var action = _a[0],
        state = _a[1];
    return reducer(action, state);
  }));
  var actionSubscription = actionSubject.subscribe(actionCache);
  var stateSubscription = state$.subscribe(stateSubject);
  var finalState$ = postUpdate ? postUpdate(stateSubject) : stateSubject;
  var enhanceStateSubscription = finalState$.subscribe(finalStateSubject);

  if (process.env.NODE_ENV === 'development') {
    var logSubscription = finalStateSubject.pipe(operators.pairwise(), operators.tap(function (_a) {
      var pre = _a[0],
          next = _a[1];
      var action = actionCache.getValue();
      console.groupCollapsed('%c action', 'color: #9E9E9E;', "" + action.type, "@ " + new Date().toLocaleTimeString());
      console.log('%c prev state', 'color: #9E9E9E; font-weight: bold', pre);
      console.log('%c action', 'color: #03A9F4; font-weight: bold', action);
      console.log('%c next state', 'color: #4CAF50; font-weight: bold', next);
      console.groupEnd();
    })).subscribe();
    stateSubscription.add(logSubscription);
  }

  var cleanup = function cleanup() {
    stateSubscription.unsubscribe();
    actionSubscription.unsubscribe();
    enhanceStateSubscription.unsubscribe();
  };

  var dispatch = function dispatch(action) {
    return actionSubject.next(action);
  };

  var store$ = finalStateSubject.pipe(operators.map(function (state) {
    var action = actionCache.getValue();
    return {
      action: action,
      state: state
    };
  }), operators.shareReplay(1));
  return {
    dispatch: dispatch,
    observe: function observe(action$, stream$) {
      var actionSub = action$.subscribe(actionCache);
      var sub = stream$.subscribe(stateSubject);
      stateSubscription.add(sub);
      actionSubscription.add(actionSub);
    },
    getState: function getState() {
      return finalStateSubject.getValue();
    },
    subscribe: function subscribe(observer) {
      return store$.subscribe(observer);
    },
    cleanup: cleanup
  };
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".Form_DQ-form-container__3QDRm {\n  flex: 1;\n  display: flex;\n  justify-content: center;\n  align-items: flex-start;\n  flex-direction: column;\n}\n";
styleInject(css_248z);

function Form(props) {
  var _this = this;

  var _a = React.useMemo(function () {
    var submitSubject = new rxjs.Subject();

    var postUpdate = function postUpdate(state$) {
      return state$.pipe(operators.map(function (state) {
        var fields = state.fields,
            meta = state.meta;
        Object.entries(fields).map(function (fieldPair) {
          return fieldPair[1];
        }); // Form error and fields errors are now separated, form error should not try to collect fields error

        var errors = meta.errors;

        var tempState = __assign(__assign({}, state), {
          meta: __assign(__assign({}, meta), {
            errors: errors
          })
        });

        var extraMeta = props.extendFormMeta ? props.extendFormMeta(tempState) : undefined;
        return __assign(__assign({}, state), {
          meta: __assign(__assign(__assign({}, meta), extraMeta), {
            errors: errors
          })
        });
      }));
    };

    var store = createStore(FORM_INIT_STATE, reducer$1, postUpdate);

    var submit = function submit() {
      submitSubject.next({
        type: FormActionTypes.submit
      });
    };

    var dispatch = function dispatch(action) {
      if (!Object.values(FormActionTypes).includes(action.type) && !Object.values(FieldActionTypes).includes(action.type)) {
        throw new Error("Invalid action: " + action.type + " is invalid");
      }

      store.dispatch(action);
    };

    var submitHandler$ = submitSubject.pipe(operators.exhaustMap(function () {
      var formState = store.getState();

      var _a = verifyForm(formState),
          formStateWithError = _a[0],
          fieldsErrors = _a[1];

      if (formStateWithError) {
        return rxjs.of(formStateWithError).pipe(operators.tap(function () {
          props.failed && props.failed(fieldsErrors, formStateWithError.values);
        }));
      }

      var loadingState = __assign(__assign({}, formState), {
        meta: __assign(__assign({}, formState.meta), {
          errors: [],
          submitting: true
        })
      });

      var finalState = __assign(__assign({}, formState), {
        meta: __assign(__assign({}, formState.meta), {
          errors: [],
          submitting: false
        })
      });

      return rxjs.merge(rxjs.of(loadingState), rxjs.of(loadingState).pipe(asyncTap(function () {
        return __awaiter(_this, void 0, void 0, function () {
          var _a, returnValue;

          return __generator(this, function (_b) {
            switch (_b.label) {
              case 0:
                _a = props.beforeSubmit;
                if (!_a) return [3
                /*break*/
                , 2];
                return [4
                /*yield*/
                , props.beforeSubmit(loadingState.values, loadingState.meta)];

              case 1:
                _a = _b.sent();
                _b.label = 2;

              case 2:
                return [4
                /*yield*/
                , props.onSubmit(loadingState.values, loadingState.meta)];

              case 3:
                returnValue = _b.sent();
                props.success && props.success(returnValue, finalState.values);
                return [2
                /*return*/
                ];
            }
          });
        });
      }), operators.mapTo(finalState), operators.catchError(function (err) {
        return rxjs.of(__assign(__assign({}, formState), {
          meta: __assign(__assign({}, formState.meta), {
            submitting: false,
            errors: [err]
          })
        })).pipe(operators.tap(function (state) {
          props.failed && props.failed(state.meta.errors, state.values);
        }));
      })));
    }));
    store.observe(submitSubject, submitHandler$);

    var resetForm = function resetForm() {
      store.dispatch({
        type: FormActionTypes.reset
      });
    };

    var updateFormValues = function updateFormValues(changes) {
      store.dispatch({
        type: FormActionTypes.update,
        payload: changes
      });
    };

    return {
      subscribe: store.subscribe,
      dispatch: dispatch,
      submit: submit,
      resetForm: resetForm,
      updateFormValues: updateFormValues,
      cleanup: store.cleanup
    };
  }, []),
      cleanup = _a.cleanup,
      formCtxValue = __rest(_a, ["cleanup"]); // eslint-disable-line react-hooks/exhaustive-deps


  var handleSubmit = function handleSubmit(evt) {
    evt.preventDefault();
    formCtxValue.submit();
  };

  React.useEffect(function () {
    return function () {
      cleanup();
    };
  }, []); // eslint-disable-line react-hooks/exhaustive-deps

  return /*#__PURE__*/React__default['default'].createElement(Provider, {
    value: formCtxValue
  }, /*#__PURE__*/React__default['default'].createElement("form", {
    className: props.className || 'DQ-form-container',
    onSubmit: handleSubmit
  }, props.children));
}

var UNIQUE_STRING = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdXRob3IiOiJEYW5ueSJ9.xeaACuv2JPWKKhl_rmAeL72LFcZvtQ4mS0cpQs6xmH8';

var useDeepCompare = function useDeepCompare(getResult, _a) {
  var defaultValue = _a.defaultValue,
      required = _a.required;
  var prevDefaultValue = React.useRef(UNIQUE_STRING);
  var prevRequired = React.useRef(required);
  React.useEffect(function () {
    if (!lodash.isEqual(defaultValue, prevDefaultValue.current) || !lodash.isEqual(required, prevRequired.current)) {
      prevDefaultValue.current = defaultValue;
      prevRequired.current = required;
      getResult();
    }
  }, [defaultValue, required]); // eslint-disable-line react-hooks/exhaustive-deps

  return null;
};

var useField = function useField(props) {
  var _a = React.useContext(FormContext),
      dispatch = _a.dispatch,
      subscribe = _a.subscribe,
      fieldPrefix = _a.fieldPrefix;

  var prefixedName = "" + (fieldPrefix || '') + props.name;

  var _b = React.useState({
    value: props.defaultValue,
    meta: {
      required: !!props.required,
      defaultValue: props.defaultValue,
      dirty: false
    }
  }),
      fieldState = _b[0],
      setFieldState = _b[1];

  var onChange = function onChange(value, otherMeta) {
    var meta = __assign({}, otherMeta);

    dispatch({
      name: prefixedName,
      type: FieldActionTypes.change,
      meta: meta,
      payload: value
    });
  };

  useDeepCompare(function () {
    dispatch({
      name: prefixedName,
      type: FieldActionTypes.register,
      meta: {
        displayName: props.displayName,
        required: !!props.required,
        defaultValue: props.defaultValue
      },
      payload: props.defaultValue
    });
  }, {
    defaultValue: props.defaultValue,
    required: !!props.required
  });
  React.useLayoutEffect(function () {
    var store$ = new Subject.Subject();
    var fieldState$ = store$.pipe(operators.map(function (store) {
      return store.state;
    }), operators.filter(function (_a) {
      var fields = _a.fields;
      return Boolean(fields[prefixedName]);
    }), operators.map(function (_a) {
      var fields = _a.fields,
          values = _a.values;
      return {
        meta: fields[prefixedName],
        value: lodash.get(values, prefixedName)
      };
    }), operators.distinctUntilChanged(lodash.isEqual), operators.tap(function (_a) {
      var meta = _a.meta,
          value = _a.value;
      setFieldState({
        value: value,
        meta: meta
      });
    }));
    var verifyField$ = store$.pipe(operators.filter(function (_a) {
      var action = _a.action,
          formState = _a.state;
      return (action.type === FieldActionTypes.change && action.name === prefixedName || action.type === FormActionTypes.update && Array.isArray(action.payload) && action.payload.some(function (c) {
        return c.path === prefixedName;
      })) && Boolean(formState.fields[prefixedName]) && (Boolean(props.validate) || !!formState.fields[prefixedName].required);
    }), operators.debounceTime(200), operators.map(function (_a) {
      var state = _a.state;
      return {
        meta: state.fields[prefixedName],
        value: lodash.get(state.values, prefixedName)
      };
    }), operators.switchMap(function (_a) {
      var value = _a.value,
          meta = _a.meta;
      return rxjs.defer(function () {
        return __awaiter(void 0, void 0, void 0, function () {
          var invalidFieldError;
          return __generator(this, function (_a) {
            switch (_a.label) {
              case 0:
                return [4
                /*yield*/
                , asyncVerifyField(meta.displayName || prefixedName, value, !!meta.required, props.validate)];

              case 1:
                invalidFieldError = _a.sent();

                if (invalidFieldError) {
                  throw invalidFieldError;
                }

                if (meta.error) {
                  dispatch({
                    name: prefixedName,
                    type: FieldActionTypes.clearError
                  });
                }

                return [2
                /*return*/
                ];
            }
          });
        });
      }).pipe(operators.catchError(function (err) {
        dispatch({
          name: prefixedName,
          type: FieldActionTypes.throwError,
          payload: err
        });
        return rxjs.of(err);
      }));
    }));
    var storeSubscription = subscribe(store$);
    var fieldStateSubscription = fieldState$.subscribe();
    var verifyFieldSubscription = verifyField$.subscribe();
    return function () {
      dispatch({
        name: prefixedName,
        type: FieldActionTypes.destroy,
        meta: {
          destroyValueOnUnmount: !!props.destroyValueOnUnmount
        }
      });
      storeSubscription.unsubscribe();
      fieldStateSubscription.unsubscribe();
      verifyFieldSubscription.unsubscribe();
    };
  }, []); // eslint-disable-line react-hooks/exhaustive-deps

  return __assign(__assign({
    path: prefixedName
  }, fieldState), {
    onChange: onChange
  });
};

var FieldOnChange = function FieldOnChange(props) {
  var _a = React.useContext(FormContext),
      updateFormValues = _a.updateFormValues,
      subscribe = _a.subscribe;

  React.useLayoutEffect(function () {
    var store$ = new rxjs.Subject();
    var localSubscription = store$.pipe(operators.filter(function (_a) {
      var action = _a.action;
      return action.type === FieldActionTypes.change;
    }), operators.map(function (_a) {
      var action = _a.action,
          state = _a.state;
      return [action, __assign({}, state.values)];
    }), operators.distinctUntilChanged(function (next, prev) {
      return lodash.isEqual(next[0], prev[0]);
    })).subscribe(function (_a) {
      var action = _a[0],
          formValues = _a[1];
      props.children({
        action: action,
        formValues: formValues,
        updateFormValues: updateFormValues
      });
    });
    var actionSubscription = subscribe(store$);
    return function () {
      localSubscription.unsubscribe();
      actionSubscription.unsubscribe();
    };
  }, []); // eslint-disable-line react-hooks/exhaustive-deps

  return null;
};

function FormMeta(props) {
  var subscribe = React.useContext(FormContext).subscribe;

  var _a = React.useState(),
      formMeta = _a[0],
      setFormMeta = _a[1];

  React.useLayoutEffect(function () {
    var store$ = new rxjs.Subject();
    var formMeta$ = store$.pipe(operators.map(function (_a) {
      var state = _a.state;
      return __assign({}, state.meta);
    }), operators.distinctUntilChanged(lodash.isEqual), operators.tap(function (meta) {
      return setFormMeta(meta);
    }));
    var formStateSubscription = subscribe(store$);
    var formMetaSubscription = formMeta$.subscribe();
    return function () {
      formStateSubscription.unsubscribe();
      formMetaSubscription.unsubscribe();
    };
  }, []); // eslint-disable-line react-hooks/exhaustive-deps

  if (!formMeta) return null;
  return props.children(formMeta);
}

function FormValues(props) {
  var subscribe = React.useContext(FormContext).subscribe;

  var _a = React.useState(),
      formValues = _a[0],
      setFormValues = _a[1];

  React.useLayoutEffect(function () {
    var store$ = new rxjs.Subject();
    var formValues$ = store$.pipe(operators.map(function (_a) {
      var state = _a.state;
      return __assign({}, state.values);
    }), operators.distinctUntilChanged(function (next, prev) {
      if (!props.filter) {
        return lodash.isEqual(next, prev);
      }

      return !props.filter(next, prev);
    }), operators.tap(function (values) {
      return setFormValues(values);
    }));
    var formStateSubscription = subscribe(store$);
    var formValueSubscription = formValues$.subscribe();
    return function () {
      formStateSubscription.unsubscribe();
      formValueSubscription.unsubscribe();
    };
  }, []); // eslint-disable-line react-hooks/exhaustive-deps

  if (!formValues) return null;
  return props.children(formValues);
}

var FormSection = function FormSection(_a) {
  var name = _a.name,
      children = _a.children;
  var formContext = React.useContext(FormContext);
  return /*#__PURE__*/React__default['default'].createElement(Provider, {
    value: __assign(__assign({}, formContext), {
      fieldPrefix: "" + (formContext.fieldPrefix || '') + name + "."
    })
  }, children);
};

exports.FieldOnChange = FieldOnChange;
exports.Form = Form;
exports.FormMeta = FormMeta;
exports.FormSection = FormSection;
exports.FormValues = FormValues;
exports.useField = useField;
