import { Observable } from 'rxjs/internal/Observable';
import { Observer } from 'rxjs/internal/types';
import { TReducer, IAction } from './interfaces';
export declare const createStore: <T, A extends IAction<string>>(initState: T, reducer: TReducer<A, T>, postUpdate?: ((state: Observable<T>) => Observable<T>) | undefined) => {
    dispatch: (action: A) => void;
    observe: (action$: Observable<A>, stream$: Observable<T>) => void;
    getState: () => T;
    subscribe: (observer: Observer<{
        action: A;
        state: T;
    }>) => import("rxjs").Subscription;
    cleanup: () => void;
};
